# ----- code 1 -----

Product = Data.define(:name, :price)

plate = Product.new(name: 'お皿', price: 2500)
puts "名前: #{plate.name}, 値段: #{plate.price}"

spoon = Product.new(name: 'スプーン', price: 1000)
another_plate = Product.new(name: 'お皿', price: 2500)
p plate == spoon
p plate == another_plate

# ----- code 2 -----

Product = Data.define(:name, :price)

# 文字列自体を変更するメソッドを使えばメンバーの値を更新できる
plate = Product.new(name: 'お皿', price: 2500)
plate.name << '（白色）'
puts "名前: #{plate.name}, 値段: #{plate.price}"

# あらかじめ文字列をfreezeすればメンバーの値を更新できない
plate = Product.new(name: 'お皿'.freeze, price: 2500)
begin
  plate.name << '（白色）'
rescue => e
  p e
end
