# ----- code 1 -----

# 位置引数で定義する
def create_user1(name, email, role)
  { name: name, email: email, role: role }
end

# キーワード引数で定義する
def create_user2(name:, email:, role:)
  { name: name, email: email, role: role }
end

p create_user1('Foo', 'foo@example.com', :none)
p create_user2(name: 'Bar', email: 'bar@example.com', role: :admin)
p create_user2(email: 'baz@example.com', role: :none, name: 'Baz')

# ----- code 2 -----

def create_user(name:, email:, role:)
  { name: name, email: email, role: role }
end

begin
  p create_user(name: 'Foo')
rescue => e
  p e
end

# ----- code 3 -----

def create_user(name:, email:, role: :none)
  { name: name, email: email, role: role }
end

p create_user(name: 'Ruby', email: 'ruby@example.com')

# ----- code 4 -----

def create_user(name, email: nil, role: :none)
  { name: name, email: email, role: role }
end

p create_user('Ruby')
p create_user('Diamond', role: :admin)

# ----- code 5 -----

def create_user(name, email: nil, role: :none)
  { name: name, email: email, role: role }
end

name = 'Ruby'
email = 'ruby@example.com'
role = :admin

p create_user(name, email: email, role: role)
# Ruby 3.1以降では以下の書き方もできる
p create_user(name, email:, role:)
