# ----- code 1 -----

def select(array, &block)
  # 最初に空配列を用意する
  result = []
  array.each do |item|
    # それぞれの要素に対してブロックを実行し、結果が真ならば配列に追加する
    result << item if block.call(item)
  end
  # 結果が真の要素だけが含まれた配列を返す
  result
end

array = [1, 2, 3, 4, 5]
# 配列から奇数のものだけを取り出す
p array.select { |number| number.odd? }
p select(array) { |number| number.odd? }

# ----- code 2 -----

def select(array)
  result = []
  array.each do |item|
    result << item if yield(item)
  end
  result
end

array = [1, 2, 3, 4, 5]
p select(array) { |number| number.odd? }

# ----- code 3 -----

def select(array)
  # ブロックが渡されていないときは配列全体をそのまま返す
  return array unless block_given?

  result = []
  array.each do |item|
    result << item if yield(item)
  end
  result
end

array = [1, 2, 3, 4, 5]
p select(array)
