# ----- code 1 -----

require 'uri'
require 'net/http'
require 'json'

# GitHubのAPIを用いてRubyのリポジトリ情報をJSON形式で取得
# 詳細は https://docs.github.com/ja/rest を参照
str = 'https://api.github.com/repos/ruby/ruby'
url = URI.parse(str)
response = Net::HTTP.get(url)
json = JSON.parse(response)
puts json['description']

# ----- code 2 -----

require 'uri'
require 'net/http'
require 'json'

puts 'https://api.github.com/repos/ruby/ruby'
  .then { |str| URI.parse(str) }
  .then { |url| Net::HTTP.get(url) }
  .then { |response| JSON.parse(response) }
  .then { |json| json['description'] }
