# code ①

def logging(&block)
  puts 'ブロック呼び出し開始'
  puts block.call
  puts 'ブロック呼び出し終了'
end

logging do
  puts 'ブロック開始'
  next 'ブロック中断'
  puts 'ブロック終了' # この行は実行されない
end

# ----- code 2 -----

class BlockCaller
  def initialize(&block)
    @block = block
  end

  def execute
    @block.call
  end
end

def execute_block_caller
  puts 'メソッド開始'
  block_caller = BlockCaller.new do
    puts 'ブロック開始'
    return # execute_block_callerから戻るためのreturnとみなされる
    puts 'ブロック終了' # この行は実行されない
  end
  block_caller.execute # execute_block_callerを終了して呼び出し元に戻る
  puts 'メソッド終了' # この行は実行されない
end

execute_block_caller

# ----- code 3 -----

# BlockCallerは上で定義したものと同じ
def create_block_caller
  BlockCaller.new do
    puts 'ブロック開始'
    return # create_block_callerから戻るためのreturnとみなされる
    puts 'ブロック終了'
  end
end

begin
  block_caller = create_block_caller
  # create_block_callerがすでに終了しているのに、
  # ブロックの中でcreate_block_callerから戻るためのreturnを実行しようとしてエラーになる
  block_caller.execute
rescue => e
  p e
end
