# ----- code 1 -----

require 'base64'

json = <<~JSON
{
  "name": "Foo",
  "comment": "こんにちは😀"
}
JSON

puts Base64.strict_encode64(json)
puts Base64.urlsafe_encode64(json)
puts Base64.urlsafe_encode64(json, padding: false)

# ----- code 2 -----

require 'base64'

strict_encoded = 'ewogICJuYW1lIjogIkZvbyIsCiAgImNvbW1lbnQiOiAi44GT44KT44Gr44Gh44Gv8J+YgCIKfQo='
urlsafe_encoded = 'ewogICJuYW1lIjogIkZvbyIsCiAgImNvbW1lbnQiOiAi44GT44KT44Gr44Gh44Gv8J-YgCIKfQo='
urlsafe_without_padding_encoded = 'ewogICJuYW1lIjogIkZvbyIsCiAgImNvbW1lbnQiOiAi44GT44KT44Gr44Gh44Gv8J-YgCIKfQo'

puts Base64.strict_decode64(strict_encoded)
puts Base64.urlsafe_decode64(urlsafe_encoded)
puts Base64.urlsafe_decode64(urlsafe_without_padding_encoded)
