# ----- code 1 -----

class Payment
  def initialize(amount:)
    @amount = amount
  end

  def total_amount
    total_amount_private
  end

  private

  def total_amount_private
    @amount + 500
  end
end

payment = Payment.new(amount: 500)
p payment.total_amount

begin
  p payment.total_amount_private
rescue => e
  p e
end

# ----- code 2 -----

class Payment
  def initialize(amount:)
    @amount = amount
  end

  def total_amount
    total_amount_protected
  end

  protected

  def total_amount_protected
    @amount + 500
  end
end

payment = Payment.new(amount: 500)
p payment.total_amount

begin
  p payment.total_amount_protected
rescue => e
  p e
end

# ----- code 3 -----

class Kansuuji
  def initialize(value)
    @value = value
    @int_value = @value.tr('〇一二三四五六七八九', '0123456789').to_i
  end

  def +(other)
    self.int_value + other.int_value
  end

  def -(other)
    self.int_value - other.int_value
  end

  protected

  def int_value
    @int_value
  end
end

p Kansuuji.new('一二三四') + Kansuuji.new('五六七八')
p Kansuuji.new('二〇二三') - Kansuuji.new('一九九三')
