require_relative 'heavy_job'

# Refinements
module HeavyJobResultCaching
  refine HeavyJob do
    def perform
      @result ||= super
    end
  end
end

class CacheableHeavyJob
  using HeavyJobResultCaching # このクラスの中だけRefinementsが有効

  def initialize
    @job = HeavyJob.new
  end

  def perform
    @job.perform
  end
end

# CacheableHeavyJobの外なのでRefinementsが無効
puts 'HeavyJob'
job = HeavyJob.new
p job.perform
p job.perform

# CacheableHeavyJobのメソッドではRefinementsが有効
puts 'CacheableHeavyJob'
job = CacheableHeavyJob.new
p job.perform
p job.perform
