# 同じディレクトリにあるcalc.rbを読み込む
require_relative 'calc'

RSpec.describe Calc do
  # receiveマッチャーを用いるパターン
  describe '#calc' do
    let(:calc) { Calc.new }

    it 'heavy_operationメソッドが呼び出される' do
      expect(calc).to receive(:heavy_operation)
      calc.calculate
    end
  end
  #
  # allowでスタブしてhave_receivedマッチャーを用いるパターン
  describe '#calc' do
    let(:calc) { Calc.new }

    before do
      allow(calc).to receive(:heavy_operation).and_return(3)
    end

    it 'heavy_operationメソッドが呼び出される' do
      calc.calculate
      expect(calc).to have_received(:heavy_operation)
    end
  end
end
