# 同じディレクトリにあるrgb.rbを読み込む
require_relative 'rgb'

RSpec.describe Rgb do
  describe '#hex' do
    let(:rgb) { Rgb.new(204, 52, 45) }

    it 'RGB値の16進数表現を返す' do
      expect(rgb.hex).to eq('#cc342d')
    end

    context 'RGB値のいずれかが1桁の16進数値になるとき' do
      let(:rgb) { Rgb.new(0, 10, 15) }
      it 'それぞれが2桁になるように0が詰められる' do
        expect(rgb.hex).to eq('#000a0f')
      end
    end

    context 'RGB値のいずれかがnilのとき' do
      let(:rgb) { Rgb.new(255, nil, nil) }

      it 'nilは0とみなされる' do
        expect(rgb.hex).to eq('#ff0000')
      end
    end
  end
end
