# 実装を単純にするため、spec_helper.rbではなく
# テストファイル内でWebMockを読み込む
require 'webmock/rspec'
# 同じディレクトリにあるgithub_stars.rbを読み込む
require_relative 'github_stars'

RSpec.describe GithubStars do
  describe '#stars' do
    let(:repo) { 'ruby/ruby' }
    let(:github_stars) { GithubStars.new(repo) }

    before do
      stub_request(:get, "https://api.github.com/repos/#{repo}")
        .to_return(
          status: 200,
          # 実際のレスポンスボディの一部分のみ抽出
          body: '{"id": 538746, "stargazers_count": 19392}',
        )
    end

    it 'リポジトリのスター数を返す' do
      expect(github_stars.stars).to eq(19392)
    end
  end
end
