# ----- code 1 -----

require 'yaml'

yaml_string = <<YAML
writers:
  - budo
  - kymmt
  - shimoju
title: The Ruby Book
publisher: 技術評論社
YAML

p YAML.load(yaml_string)

# ----- code 2 -----

require 'yaml'

p YAML.load_file('book.yaml')

# ----- code 3 -----

require 'yaml'

yaml_string = <<YAML
writers:
  - budo
  - kymmt
  - shimoju
title: The Ruby Book
publisher: 技術評論社
YAML

p YAML.load(yaml_string, symbolize_names: true)

# ----- code 4 -----

require 'yaml'
require 'date'

yaml_string = <<YAML
writers:
  - budo
  - kymmt
  - shimoju
title: The Ruby Book
publisher: 技術評論社
range: !ruby/range
  begin: 1
  end: 100
  excl: false
date: 2023-01-28
YAML

puts (YAML.load(yaml_string) rescue "読み込めないクラスがあります")
puts YAML.load(yaml_string, permitted_classes: [Date, Range])
puts YAML.unsafe_load(yaml_string)
