# ----- code 1 -----

require 'rubyXL'

workbook = RubyXL::Parser.parse('users.xlsx')

# ----- code 2 -----

require 'csv'
require 'rubyXL'

# XLSXファイルを表すオブジェクトを新規に作成する
workbook = RubyXL::Workbook.new

users = CSV.read('users.csv')

# 1枚目のシートにusers.csvから読み込んだデータを入力する
worksheet1 = workbook.worksheets[0]
worksheet1.sheet_name = 'ユーザー'
users.each_with_index do |row, i|
  row.each_with_index do |value, j|
    # i番目の行のj番目の列のセルにvalueを入力する
    value = value.to_i if value.match?(/\A\d+\z/)
    worksheet1.add_cell(i, j, value)
  end
end

orders = CSV.read('orders.csv')

# 2枚目のシートにorders.csvから読み込んだデータを入力する
worksheet2 = workbook.add_worksheet('注文')
orders.each_with_index do |row, i|
  row.each_with_index do |value, j|
    # i番目の行のj番目の列にvalueを入力する
    value = value.to_i if value.match?(/\A\d+\z/)
    worksheet2.add_cell(i, j, value)
  end
end
worksheet2.add_cell(orders.size, 2, nil, 'SUM(C2:C5)')

# XLSXファイルを保存する
workbook.write('output.xlsx')
