require 'net/http'
require 'nokogiri'

response = Net::HTTP.get(URI.parse('https://www.ruby-lang.org/ja/'))
doc = Nokogiri::HTML5(response)

# idがintroであるdiv要素の子孫であるh1タグのうち、
# 最初に登場する要素のテキストを取得する
# これらはすべて同様の結果になる
puts doc.css('div#intro h1').first.text
puts doc.at_css('div#intro h1').text
puts doc.xpath('//div[@id="intro"]//h1').first.text
puts doc.at_xpath('//div[@id="intro"]//h1').text

# classがsite-linksである要素の子孫で、3番目のa要素のhref属性を取得する
puts doc.at_css('.site-links a:nth-of-type(3)').attr('href')
puts doc.at_xpath('//*[@class="site-links"]//a[3]/@href').value
