# ----- code 1 -----

require 'net/http'
require 'json'
require 'time'

repo = 'ruby/ruby'
api_url = URI.parse("https://api.github.com/repos/#{repo}/pulls")
# クエリ文字列でオプションを指定する
# クローズされているものを、更新日時の降順でソートし、50件取得
api_url.query = 'state=closed&sort=updated&direction=desc&per_page=50'
response = Net::HTTP.get(api_url)
JSON.parse(response)
    # クローズされたPull Requestはマージされていないものも含むため、マージ時刻が存在するもののみを抽出する
    .select { |pr| pr['merged_at'] }
    .each { |pr|
  puts <<~EOS
    # [#{pr['title']}](#{pr['html_url']})
    ##{pr['number']} by #{pr['user']['login']} merged at #{Time.parse(pr['merged_at']).strftime('%Y-%m-%d %H:%M')}
    > #{pr['body'] ? pr['body'].split(/\R/).first : 'No description provided.'}
  EOS
}

# ----- code 2 -----

require 'octokit'

repo = 'ruby/ruby'
client = Octokit::Client.new
client
  .pull_requests(repo, state: 'closed', sort: 'updated', direction: 'desc', per_page: 50)
  .select { |pr| pr.merged_at? }
  .each { |pr|
  puts <<~EOS
    # [#{pr.title}](#{pr.html_url})
    ##{pr.number} by #{pr.user.login} merged at #{pr.merged_at.strftime('%Y-%m-%d %H:%M')}
    > #{pr.body? ? pr.body.split(/\R/).first : 'No description provided.'}

  EOS
}
