require 'rack'
require 'rack/attack'
require_relative 'sample_app'

use Rack::Attack

Rack::Attack.blocklist('block curl') do |request|
  request.path == '/useragent' &&
    request.user_agent.match?(/curl/)
end

Rack::Attack.blocklist('block admin access') do |request|
  request.path == '/admin'
end

Rack::Attack.safelist('allow localhost') do |request|
  request.path == '/admin' && ['127.0.0.1', '::1'].include?(request.ip)
end

run SampleApp.new
