class ReplaceHello
  def initialize(app)
    @app = app
  end

  def call(env)
    status, headers, body = @app.call(env)
    replaced = false

    body.each do |b|
      if b.gsub!(/hello/i, 'こんにちは')
        replaced = true
      end
    end

    headers['x-replace-hello'] = replaced.to_s
    response = Rack::Response.new(body.join, status, headers)
    response.finish
  end
end
