require 'digest'

class TokenAuthentication
  HASHED_TOKEN = Digest::SHA256.digest('foobarbazqux')
  def initialize(app)
    @app = app
  end

  def call(env)
    token = env['HTTP_AUTHORIZATION'].to_s.delete_prefix('Bearer ')

    if Rack::Utils.secure_compare(
      HASHED_TOKEN, Digest::SHA256.digest(token)
    )
      @app.call(env)
    else
      response = Rack::Response.new('Unauthorized', 401)
      response.content_type = 'text/plain'
      response.finish
    end
  end
end
